async function createTranslator(dictionaryFilePath)
{
    let projectPath = await desiteAPI.getProjectDirectory();
    let filePath = projectPath + dictionaryFilePath;
    let fileExists = await desiteAPI.checkIfFileExists(filePath);
    let translator = {};
    if (fileExists)
    {
        let dictionary = JSON.parse(await desiteAPI.readTextFileAsString(filePath, "UTF-8"));     
        translator =
        {
            dictionary: dictionary,
            currentLanguage: 'undefined'
        };
    }    
    else
    {
        alert(`ERROR: Couldn't find dictionary file '${dictionaryFilePath}'`);
    }
    return translator;
}

function setCurrentLanguage(translator, currentLanguage)
{        
    let dictionary = translator.dictionary;    
    let language = '';
    let languages = dictionary.languages;
    for (i in languages)
    {
        if (languages[i] == currentLanguage)
        {
            language = currentLanguage;
            let translations = dictionary.translations;
            for (j in translations)
            {
                let translation = translations[j];
                let key = Object.keys(translation)[0];
                let element = document.getElementById("translate:" + key);
                if(element)
                {
                    value = (language in translation[key] ? translation[key][language] : "missing");
                    if (element.type == "button")
                    {
                        element.value = value;
                    }
                    else
                    {
                        element.innerHTML = '';
                        element.innerHTML = value;                        
                    }
                }
            }
            break;
        }
    }
    translator.currentLanguage = language;
}

function getTranslatedString(translator, key, defaultString)
{
    let string = defaultString;
    if(translator.currentLanguage)
    {
        let translations = translator.dictionary.translations;
        for (i in translations)
        {
            let translation = translations[i];
            if(translation[key])
                string = translation[key][translator.currentLanguage];
        }    
    }
    return string;
}

function getCurrentLanguage(translator)
{
    return translator.currentLanguage;
}